from datetime import datetime, timedelta
from erasure import *
from police import local_police
from log import log
from locker import locker

####################
##SYSTEM INTERNALS## 
####################
##ADMINS
ADM=set(['root1','root2','police'])

##I/O SUBSYSTEM
def getFingerprint():
  z=raw_input()
  return z
def dump(list):
  for e in list:
    print e

#################
##ERASURE SETUP##
#################
getFingerprint=erasure_source(getFingerprint)
hash = retain(hash)
dump=erasure_escape(dump)

###############################
##USER DEFINED ERASURE POLICY##
###############################
##Erase data older than 20 seconds
def fivedays_policy(time):
  return (datetime.today()-time)>timedelta(seconds=20) #in the paper timedelta(days=5), a little bit slow

lazy_erasure(fivedays_policy)

##Erase data which were not erased earlier when an admin (not policeman) is dumping the log
def role_policy(time):
  global police_mode
  return not(police_mode)

#####################
##THE LOCKER SYSTEM##
#####################
def lockerSystem():
  global police_mode
  police_mode=False
  while(True):
    print 'Welcome to the locker system'
    fingerprint=getFingerprint()
    ts=datetime.today()
    if fingerprint in ADM:
      log.add('MEMORY DUMP -->'+fingerprint+': '+str(ts))
      if fingerprint=='police':
        police_mode=True
      dump(log.getLog())
      police_mode=False
    else:
      suspect=local_police.check(fingerprint)
      h = hash(fingerprint)
      if suspect==False:
        lazy_erasure(fingerprint)
      elif suspect=='no_connection': 
        lazy_erasure(fingerprint,role_policy)
      else:
        pass
      if locker.isFree():
        key = h
        locker.occupied()
        print 'Please, do not forget to retrive your goods'
        log.add('LOCKED -->'+fingerprint+': '+str(ts))
      else:
        if key == h:
          locker.free()
          print 'Thanks for using the service'
          log.add('UNLOCKED -->'+fingerprint+': '+str(ts))
        else:
          print 'You are not the right owner'
          log.add('INVALID ACCESS -->'+fingerprint+': '+str(ts))
          
if __name__ == "__main__":
  lockerSystem()
